package com.example.nto.entity;

import com.fasterxml.jackson.annotation.JsonIgnore;
import lombok.Data;
import org.springframework.security.core.GrantedAuthority;
import org.springframework.security.core.userdetails.UserDetails;

import javax.persistence.*;
import java.time.LocalDateTime;
import java.util.Collection;
import java.util.List;
import java.util.Set;

@Data
@Entity
@Table(name = "users")
public class Users implements UserDetails {
    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private long id;
    @Column(name = "username")
    private String username;
    @Column(name = "name")
    private String name;
    @Column(name = "password")
    private String password;
    @ManyToOne
    @JoinColumn(name = "authority_id")
    @JsonIgnore
    private Authority authority;
    @ManyToOne
    @JoinColumn(name = "credentials")
    @JsonIgnore
    private Credentials credentials;
    @Column(name = "photo")
    private String photo;
    @Column(name = "position")
    private String position;
    @ManyToMany(fetch = FetchType.EAGER)
    private Set<Authority> authorities;
    @Column(name = "lastVisit")
    private LocalDateTime lastVisit;
    @Column(name = "iscardblocked")
    private Boolean isCardBlocked;


    @Override
    public Collection<? extends GrantedAuthority> getAuthorities() {
        return List.of();
    }



    @Override
    public boolean isAccountNonExpired() {
        return true;
    }

    @Override
    public boolean isAccountNonLocked() {
        return true;
    }

    @Override
    public boolean isCredentialsNonExpired() {
        return true;
    }

    @Override
    public boolean isEnabled() {
        return true;
    }

}